//
//	Cu "wCan2515"
//		copyright (c) 2010,2011,2012 T.Nakao
//
//		10/05/xx
//


#include <avr/io.h>
#include "wCan2515.h"

//#include "WProgram.h"		// o[W
#include "Arduino.h"		// Vo[W

#include "P2515Tag.h"
#include "P2515Reg.h"


// nh
void (*wCan2515::user_onReceive)(uint8_t rslt);
void (*wCan2515::user_onTxComp0)(void);
void (*wCan2515::user_onTxComp1)(void);
void (*wCan2515::user_onTxComp2)(void);




//---------------------------------------------------
//	RXgN^
//---------------------------------------------------
wCan2515::wCan2515(uint8_t sck, uint8_t si, uint8_t so, uint8_t ss, uint8_t rate)
{
int i;
	// MCP2515pSPI|[g̐ݒ
	pinSck = sck;
	pinSi = si;
	pinSo = so;
	pinSs = ss;

	pinMode(sck, OUTPUT);
	pinMode(si,  INPUT );
	pinMode(so,  OUTPUT);
	pinMode(ss,  OUTPUT);

	// SPIoX ACh
	CAN_SPI_CS_H;
	CAN_SPI_SCK_L;

//	delay(1);

	Reset();
//	delay(1);

//	BitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), (1<<B0BFS) | (1<<B0BFE));		// LED3

	Init(rate);
//	BitModCmd(BFPCTRL, (1<<B0BFS) | (1<<B0BFE), (1<<B0BFS) | (1<<B0BFE));		// LED3

}


//---------------------------------------------------
// SPI 1oCg[h/Cg
//---------------------------------------------------
uint8_t wCan2515::SpiRW(uint8_t outdat) {
	uint8_t i, indat = 0;

	for(i = 0; i < 8; i++) {
		// f[^write
		if(outdat & 0x80) {
			// 1
			CAN_SPI_SO_H;
		} else {
			// 0
			CAN_SPI_SO_L;
		}
		outdat <<= 1;

		// f[^read
		indat <<= 1;
		if(CAN_SPI_SI) {
			// 1
			indat |= 1;
		}

		CAN_SPI_SCK_H;		// SCK pXo
		CAN_SPI_SCK_L;
	}

	return indat;
}


//---------------------------------------------------
// CANRg[MCP2515 \tgEFAEZbg
//---------------------------------------------------
void wCan2515::Reset(void) {
	uint8_t i;
	uint8_t cmd = SPI_INST_RESET;

	CAN_SPI_CS_L;

	SpiRW(cmd);

	CAN_SPI_CS_H;
}


//---------------------------------------------------
// CANRg[MCP2515̏
//---------------------------------------------------
void wCan2515::Init(uint8_t rate) {

	SetOpMode(CAM_MODE_CONFIG);

	// MCP2515 RtBM[Vݒ
	// {[[gݒ 125kbps (X=20MHz)
	// Tq = (2 x (BRP + 1))/Fosc )
	WriteReg(CAN_CNF1, rate);

	// PRSEG = 1;				// ProgSeg = 2
	// PHSEG1 = 6;				// PH1 = 7
	// SAM = 0;
	// BTLMODE = 1;
	WriteReg(CAN_CNF2, 0xB1);

	// PHSEG2 = 5;				// PH2 = 6
	// WAKFIL = 0;
	// SOF = 0;
	WriteReg(CAN_CNF3, 0x05);

	TxPend[0] = false;
	TxPend[1] = false;
	TxPend[2] = false;
}


//---------------------------------------------------
// MID}XN̐ݒ
//---------------------------------------------------
void wCan2515::SetMask(uint8_t mask_num, uint16_t sid) {
	uint8_t adrs;

	switch(mask_num) {
		case 0:
			adrs = RXM0SIDH;
			break;
		default:
			adrs = RXM1SIDH;
			break;

	}

	WriteReg(adrs, (byte)(sid>>3));			// HIGH
	WriteReg(adrs + 1, (byte)(sid<<5));		// LOW
}


//---------------------------------------------------
// MID}XN̐ݒimask0pj
//---------------------------------------------------
void wCan2515::SetMask(uint16_t sid) {
	uint8_t adrs;

	adrs = RXM0SIDH;

	WriteReg(adrs, (byte)(sid>>3));			// HIGH
	WriteReg(adrs + 1, (byte)(sid<<5));		// LOW
}


//---------------------------------------------------
// MIDtB^̐ݒ
//---------------------------------------------------
void wCan2515::SetFilter(uint8_t filter_num, uint16_t sid) {
	uint8_t adrs;

	switch(filter_num) {
		case 0:
			adrs = RXF0SIDH;
			break;
		case 1:
			adrs = RXF1SIDH;
			break;
		case 2:
			adrs = RXF2SIDH;
			break;
		case 3:
			adrs = RXF3SIDH;
			break;
		case 4:
			adrs = RXF4SIDH;
			break;
		default:
			adrs = RXF5SIDH;
			break;

	}

	WriteReg(adrs, (byte)(sid>>3));			// HIGH
	WriteReg(adrs + 1, (byte)(sid<<5));		// LOW
}


//---------------------------------------------------
// MIDtB^̐ݒifilter0pj
//---------------------------------------------------
void wCan2515::SetFilter(uint16_t sid) {
	uint8_t adrs;

	adrs = RXF0SIDH;

	WriteReg(adrs, (byte)(sid>>3));			// HIGH
	WriteReg(adrs + 1, (byte)(sid<<5));		// LOW
}


//---------------------------------------------------
// tB^E[h̐ݒ
//---------------------------------------------------
void wCan2515::SetFilterMode(uint8_t buf_num, uint8_t mode) {
	if(buf_num == 0) {
		// RXBUF0
		WriteReg(RXB0CTRL, mode<<5);
	} else {
		// RXBUF1
		WriteReg(RXB1CTRL, mode<<5);
	}
}


//---------------------------------------------------
// bZ[Wƃf[^ݒ (type1)
//		Mobt@TxBuf[14]̓e2515TXBnɐݒ
//---------------------------------------------------
void wCan2515::SetTxBuf(uint8_t buf_num, uint8_t dat_siz) {
	uint8_t cmd;

	switch(buf_num) {
		case 0:
			cmd = LD_TXBUF_TXB0SIDH;
			break;
		case 1:
			cmd = LD_TXBUF_TXB1SIDH;
			break;
		default:
			cmd = LD_TXBUF_TXB2SIDH;
			break;
	}

	TxRxBufRW(cmd, 0, &TxBuf[1], 5 + dat_siz);
}


//---------------------------------------------------
// bZ[Wƃf[^ݒ (type2)
//		񑗐Mobt@ɐݒ肵ƁA2515TXBnɐݒ
//---------------------------------------------------
void wCan2515::SetTxBuf(uint8_t buf_num, uint16_t message,
							uint8_t dat[8], uint8_t dat_siz, uint8_t dtfam) {
	uint8_t cmd, buf[13];

	switch(buf_num) {
		case 0:
			cmd = LD_TXBUF_TXB0SIDH;
			break;
		case 1:
			cmd = LD_TXBUF_TXB1SIDH;
			break;
		default:
			cmd = LD_TXBUF_TXB2SIDH;
			break;
	}

	if(dat_siz > 8) {
		dat_siz = 8;
	}

	TxBuf[0] = 0;						// CTRL(_~[)
	TxBuf[1] = GET_SIDH(message);		// SIDH
	TxBuf[2] = GET_SIDL(message);		// SIDL
	TxBuf[3] = 0;						// EID8
	TxBuf[4] = 0;						// EID0
	TxBuf[5] = dat_siz & 0x0F;			// DLC

	if(!dtfam) {
		// [gEt[̂Ƃ
		TxBuf[5] |= (1<<RTR);
	}

	memcpy(&TxBuf[6], dat, dat_siz);		// D0-D7

	TxRxBufRW(cmd, 0, &TxBuf[1], 5 + dat_siz);
}


//---------------------------------------------------
// Mv
//---------------------------------------------------
void wCan2515::TxReq(uint8_t buf_num) {
	uint8_t cmd;

	switch(buf_num) {
		case 0:
			cmd = TXB0CTRL;
			break;
		case 1:
			cmd = TXB1CTRL;
			break;
		default:
			cmd = TXB2CTRL;
			buf_num = 2;
			break;
	}

	TxPend[buf_num] = true;

	// MJn
	WriteReg(cmd, 1<<TXREQ);	// SPIR}h Mv
}


//---------------------------------------------------
// M`FbNiʐMG[A╉̎ đj
//---------------------------------------------------
uint8_t wCan2515::CheckTxComp(uint8_t buf_num) {
	uint8_t ctrl, reg, rslt = false;

	switch(buf_num) {
		case 0:
			ctrl = TXB0CTRL;
			break;
		case 1:
			ctrl = TXB1CTRL;
			break;
		default:
			ctrl = TXB2CTRL;
			buf_num = 2;
			break;
	}

	if(TxPend[buf_num]) {
		// Mobt@n̑MĂȂƂ
		reg = ReadReg(ctrl);			// Mobt@n CTRL
		if(!(reg & 1<<TXREQ)) {
			// M
			TxPend[buf_num] = false;
			rslt = true;

			// nhR[
			switch(buf_num) {
				case 0:
					if(user_onTxComp0) {
						user_onTxComp0();
					}
					break;
				case 1:
					if(user_onTxComp1) {
						user_onTxComp1();
					}
					break;
				default:
					if(user_onTxComp2) {
						user_onTxComp2();
					}
					break;
			}
		} else {
			if( (reg & 1<<MLOA) || (reg & 1<<TXERR) ) {	// đ
				// ╉ ܂ MG[
				BitModCmd(ctrl, 1<<TXREQ, 0);			// MA{[g
				BitModCmd(ctrl, 1<<TXREQ, 1<<TXREQ);	// Mvs(đ)
			}
		}
	}

	return rslt;
}


//---------------------------------------------------
// Mobt@烁bZ[WAf[^ǂݏo(type2)
//		_~[(1){bZ[W(5){f[^(8) v14oCg
//---------------------------------------------------
uint16_t wCan2515::GetRxBuf(uint8_t buf_num, uint8_t dat[8], uint8_t *size, uint8_t *datfrm) {
	uint8_t cmd;
	uint16_t msg;

	if(buf_num == 0) {
		// RXBUF0
		cmd = RD_RXBUF_RXB0SIDH;
	} else {
		// RXBUF1
		cmd = RD_RXBUF_RXB1SIDH;
	}

	TxRxBufRW(cmd, 1, &RxBuf[1], 5 + 8);	// 2515ǂݏo

	msg = MAKE_SID(RxBuf[1], RxBuf[2]);

	RxBuf[0] = 0;							// CTLR(_~[)
	*size = RxBuf[5] & 0x0F;				// DLC

	if(RxBuf[5] & 1<<RTR) {
		*datfrm = true;						// CANf[^Et[
	} else {
		*datfrm = false;					// CAN[gEt[
	}

	memcpy(dat, &RxBuf[6], *size);			// f[^Ԃ

	return msg;
}


//---------------------------------------------------
// CANMnho^
//---------------------------------------------------
void wCan2515::OnReceive(void (*function)(uint8_t)) {
	user_onReceive = function;
}


//---------------------------------------------------
// CANMnho^(Mobt@0)
//---------------------------------------------------
void wCan2515::OnTxComp0(void (*function)(void)) {
	user_onTxComp0 = function;
}


//---------------------------------------------------
// CANMnho^(Mobt@1)
//---------------------------------------------------
void wCan2515::OnTxComp1(void (*function)(void)) {
	user_onTxComp1 = function;
}


//---------------------------------------------------
// CANMnho^(Mobt@2)
//---------------------------------------------------
void wCan2515::OnTxComp2(void (*function)(void)) {
	user_onTxComp2 = function;
}




// --------------------------------------------------------------------
// CANM`FbN
// --------------------------------------------------------------------
uint8_t wCan2515::RxCheck(uint8_t rxbnum) {
	uint8_t rxstat, rslt;

	rxstat = ReadRXStat();			// MXe[^X擾

	switch(rxbnum) {
		case 0:
			rslt = rxstat & 1<<MsgInRXB0;
			break;
		case 1:
			rslt = rxstat & 1<<MsgInRXB1;
			break;
		default:
			rslt = rxstat & ( (1<<MsgInRXB0) | (1<<MsgInRXB1) );
			break;
	}

	if(rslt && user_onReceive) {
		// MŃnho^ĂƂ
		user_onReceive(rslt);				// nhR[
	}

	return rslt;
}


// --------------------------------------------------------------------
// CANRg[ [hݒ
// --------------------------------------------------------------------
void wCan2515::SetOpMode(uint8_t mode) {
	BitModCmd(CANCTRL, 7<<5, mode<<5);
}


// --------------------------------------------------------------------
// CANWX^ oCgECg
// --------------------------------------------------------------------
void wCan2515::WriteReg(uint8_t adrs, uint8_t data) {

	uint8_t cmdbf[3], cmd;
	uint8_t i;

	cmdbf[0] = SPI_INST_WRITE;		// oCgECg
	cmdbf[1] = adrs;
	cmdbf[2] = data;

	CAN_SPI_CS_L;

	for(i = 0; i < 3; i++) {
		cmd = cmdbf[i];
		SpiRW(cmd);
	}

	CAN_SPI_CS_H;
}


// --------------------------------------------------------------------
// CANWX^E[h
// Xe[^XE[h
// MXe[^XE[h  (3@\p[`)
// --------------------------------------------------------------------
uint8_t wCan2515::RegRead2B(uint8_t inst, uint8_t adrs) {
	uint8_t cmdbf[2], cmd;
	uint8_t i, dat;

	cmdbf[0] = inst;		// CXgNV
	cmdbf[1] = adrs;

	CAN_SPI_CS_L;

	// 2oCgo(f[^͖͂)
	for(i = 0; i < 2; i++) {
		cmd = cmdbf[i];
		SpiRW(cmd);
	}

	// f[^(Xe[^X̏ꍇ́A2ڂ̃s[gf[^)
	dat = SpiRW(0);

	CAN_SPI_CS_H;

	return dat;
}




// --------------------------------------------------------------------
// WX^ oCgE[h
// --------------------------------------------------------------------
uint8_t wCan2515::ReadReg(uint8_t adrs) {
	return RegRead2B(SPI_INST_READ, adrs);
}


// --------------------------------------------------------------------
// Xe[^XE[h
// --------------------------------------------------------------------
uint8_t wCan2515::ReadStat(void) {
	return RegRead2B(SPI_INST_RD_STAT, 0);
}


// --------------------------------------------------------------------
// MXe[^XE[h
// --------------------------------------------------------------------
uint8_t wCan2515::ReadRXStat(void) {
	return RegRead2B(SPI_INST_RX_STAT, 0);
}


// --------------------------------------------------------------------
// CANrbgEft@CER}h
// --------------------------------------------------------------------
void wCan2515::BitModCmd(uint8_t adrs, uint8_t mask, uint8_t data) {
	uint8_t cmdbf[4], cmd;
	uint8_t i;

	cmdbf[0] = SPI_INST_BIT_MOD;		// rbgEft@C
	cmdbf[1] = adrs;
	cmdbf[2] = mask;
	cmdbf[3] = data;

	CAN_SPI_CS_L;

	for(i = 0; i < 4; i++) {
		cmd = cmdbf[i];
		SpiRW(cmd);
	}
	CAN_SPI_CS_H;
}


// --------------------------------------------------------------------
// CAN^Mobt@ V[PVE[h^Cg (p[`)
// --------------------------------------------------------------------
void wCan2515::TxRxBufRW(uint8_t inst, uint8_t readop, uint8_t *data, uint8_t cnt) {

	uint8_t dat;
	uint8_t i;

	CAN_SPI_CS_L;

	// CXgNV̑M
	dat = inst;
	SpiRW(dat);

	// =============== M/Mobt@ȇM =================
	if(readop) {
		// f[^M
		for(i = 0; i < cnt; i++) {
			dat = SpiRW(0);
			data[i] = dat;
		}
	} else {
		// f[^M
		for(i = 0; i < cnt; i++) {
			dat = data[i];
			SpiRW(dat);
		}
	}

	CAN_SPI_CS_H;

	return;
}

